Sequel.migration do
    change do
        create_table :puzzles do
            primary_key :id

            # The markdown text of the message
            String :text, null: false

            # One of these must be present
            String :solution, null: true # A string to compare against
            String :check_solution, null: true # a ruby expression that will evaluate to true or false. `discord_username` and `submission` are in scope.

            # We need a public_id or title that we can use to identify the puzzle, for example when upserting toml
            # This is publicly displayed in hex, but stored as an integer so that we can sort
            # This is the order that the puzzles are released
            # Unreleased puzzles may have a null public_id
            Integer :public_id, null: true

            # To facilitate editing puzzle messages, we want to store the Discord message id
            # Obviously null if it hasn't been sent yet
            Integer :message_id, null: true

            # draft / ready / current / used
            String :state, default: "draft", null: false

            # Timestamps
            DateTime :created_at, null: false
            DateTime :updated_at, null: false
        end
    end
end
